/*
 * ExactPatternMatch.cpp
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#include "ExactPatternMatch.h"
#include <registration/AlgoRegistration.hpp>

namespace arbology {

namespace exact {

auto ExactPatternMatchUnrankedPattern = registration::AbstractRegister < ExactPatternMatch, ext::set < unsigned >, const tree::UnrankedTree < > &, const tree::UnrankedPattern < > & > ( ExactPatternMatch::match );
auto ExactPatternMatchRankedPattern = registration::AbstractRegister < ExactPatternMatch, ext::set < unsigned >, const tree::RankedTree < > &, const tree::RankedPattern < > & > ( ExactPatternMatch::match );
auto ExactPatternMatchRankedNonlinearPattern = registration::AbstractRegister < ExactPatternMatch, ext::set < unsigned >, const tree::RankedTree < > &, const tree::RankedNonlinearPattern < > & > ( ExactPatternMatch::match );
auto ExactPatternMatchPrefixRankedPattern = registration::AbstractRegister < ExactPatternMatch, ext::set < unsigned >, const tree::PrefixRankedTree < > &, const tree::PrefixRankedPattern < > & > ( ExactPatternMatch::match );
auto ExactPatternMatchPrefixRankedNonlinearPattern = registration::AbstractRegister < ExactPatternMatch, ext::set < unsigned >, const tree::PrefixRankedTree < > &, const tree::PrefixRankedNonlinearPattern < > & > ( ExactPatternMatch::match );
auto ExactPatternMatchPrefixRankedBarPattern = registration::AbstractRegister < ExactPatternMatch, ext::set < unsigned >, const tree::PrefixRankedBarTree < > &, const tree::PrefixRankedBarPattern < > & > ( ExactPatternMatch::match );
auto ExactPatternMatchPrefixRankedBarNonlinearPattern = registration::AbstractRegister < ExactPatternMatch, ext::set < unsigned >, const tree::PrefixRankedBarTree < > &, const tree::PrefixRankedBarNonlinearPattern < > & > ( ExactPatternMatch::match );

} /* namespace exact */

} /* namespace arbology */
