/*
 * ToGrammar.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _AUTOMATON_TO_GRAMMAR_H__
#define _AUTOMATON_TO_GRAMMAR_H__

#include <grammar/Regular/LeftRG.h>
#include <automaton/FSM/NFA.h>
#include <automaton/FSM/DFA.h>
#include "ToGrammarRightRG.h"

namespace automaton {

namespace convert {

class ToGrammar {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	template < class SymbolType, class StateType >
	static grammar::RightRG < > convert(const automaton::NFA < SymbolType, StateType > & automaton);
	template < class SymbolType, class StateType >
	static grammar::RightRG < > convert(const automaton::DFA < SymbolType, StateType > & automaton);
};

template < class SymbolType, class StateType >
grammar::RightRG < > ToGrammar::convert(const automaton::NFA < SymbolType, StateType > & automaton) {
	return grammar::RightRG < >(ToGrammarRightRG::convert(automaton));
}

template < class SymbolType, class StateType >
grammar::RightRG < > ToGrammar::convert(const automaton::DFA < SymbolType, StateType > & automaton) {
	return grammar::RightRG < >(ToGrammarRightRG::convert(automaton));
}


} /* namespace convert */

} /* namespace automaton */

#endif /* _AUTOMATON_TO_GRAMMAR_H__ */
