/*
 * Author: Radovan Cerveny
 */

#ifndef STRINGOLOGY_BACKWARD_DAWG_MATCHING_H__
#define STRINGOLOGY_BACKWARD_DAWG_MATCHING_H__

#include <string/StringFeatures.h>
#include <automaton/AutomatonFeatures.h>

#include <set>

namespace stringology {

namespace query {

/**
 * Implementation of Backward DAWG Matching.
 */
class BackwardDAWGMatching {
public:
	/**
	 * Search for pattern in linear string.
	 * @return set set of occurences
	 */
	static ext::set < unsigned > match ( const string::LinearString < > & subject, const automaton::DFA < > & suffixAutomaton );

};

} /* namespace query */

} /* namespace stringology */

#endif /* STRINGOLOGY_BACKWARD_DAWG_MATCHING_H__ */
