/*
 * Author: Radovan Cerveny
 */

#ifndef STRINGOLOGY_BACKWARD_ORACLE_MATCHING_H__
#define STRINGOLOGY_BACKWARD_ORACLE_MATCHING_H__

#include <string/LinearString.h>
#include <automaton/FSM/DFA.h>

#include <set>

namespace stringology {

namespace query {

/**
 * Implementation of Backward Oracle Matching.
 */
class BackwardOracleMatching {
public:
	/**
	 * Search for pattern in linear string.
	 * @return set set of occurences
	 */
	static ext::set < unsigned > match ( const string::LinearString < > & subject, const automaton::DFA < > & factorOracle );

};

} /* namespace query */

} /* namespace stringology */

#endif /* STRINGOLOGY_BACKWARD_ORACLE_MATCHING_H__ */
