#include "FactorOracleAutomatonTest.h"

#include "string/LinearString.h"
#include "stringology/indexing/ExactFactorOracleAutomaton.h"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( FactorOracleAutomatonTest, "stringology" );
CPPUNIT_TEST_SUITE_REGISTRATION ( FactorOracleAutomatonTest );

void FactorOracleAutomatonTest::setUp ( ) {
}

void FactorOracleAutomatonTest::tearDown ( ) {
}

void FactorOracleAutomatonTest::testFactorOracleConstruction ( ) {
	string::LinearString < > pattern ( "atatac" );

	automaton::DFA<> oracle = stringology::indexing::ExactFactorOracleAutomaton::construct ( pattern );

	automaton::DFA<> refOracle ( DefaultStateType ( 0 ) );

	refOracle.addFinalState ( DefaultStateType ( 0 ) );

	refOracle.setInputAlphabet ( pattern.getAlphabet ( ) );

	for ( int i = 1; i <= 6; ++i ) {
		refOracle.addState ( DefaultStateType ( i ) );
		refOracle.addFinalState ( DefaultStateType ( i ) );
	}

	refOracle.addTransition ( DefaultStateType ( 0 ), DefaultSymbolType ( 'a' ), DefaultStateType ( 1 ) );
	refOracle.addTransition ( DefaultStateType ( 0 ), DefaultSymbolType ( 't' ), DefaultStateType ( 2 ) );
	refOracle.addTransition ( DefaultStateType ( 0 ), DefaultSymbolType ( 'c' ), DefaultStateType ( 6 ) );
	refOracle.addTransition ( DefaultStateType ( 1 ), DefaultSymbolType ( 't' ), DefaultStateType ( 2 ) );
	refOracle.addTransition ( DefaultStateType ( 1 ), DefaultSymbolType ( 'c' ), DefaultStateType ( 6 ) );
	refOracle.addTransition ( DefaultStateType ( 2 ), DefaultSymbolType ( 'a' ), DefaultStateType ( 3 ) );
	refOracle.addTransition ( DefaultStateType ( 3 ), DefaultSymbolType ( 't' ), DefaultStateType ( 4 ) );
	refOracle.addTransition ( DefaultStateType ( 3 ), DefaultSymbolType ( 'c' ), DefaultStateType ( 6 ) );
	refOracle.addTransition ( DefaultStateType ( 4 ), DefaultSymbolType ( 'a' ), DefaultStateType ( 5 ) );
	refOracle.addTransition ( DefaultStateType ( 5 ), DefaultSymbolType ( 'c' ), DefaultStateType ( 6 ) );

	CPPUNIT_ASSERT ( oracle == refOracle );
}
