/*
 * ExceptionAccess.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#include "ExceptionAccess.h"

#include <factory/XmlDataFactory.hpp>
#include <container/xml/ObjectsSet.h>
#include <container/xml/ObjectsMap.h>
#include <container/xml/ObjectsTuple.h>
#include <container/xml/ObjectsVector.h>
#include <container/xml/ObjectsVariant.h>
#include <container/xml/ObjectsPair.h>
#include <container/xml/ObjectsTree.h>

namespace dataAccess {

void ExceptionAccess::access ( const exception::CommonException & exception, const ExceptionSettings::Settings & settings, const OperationSettings::Settings & operation ) {
	if ( settings == ExceptionSettings::Settings::CAUSE && operation == OperationSettings::Settings::GET ) {
		std::cout << exception.getCause ( );
		return;
	}

	if ( settings == ExceptionSettings::Settings::BACKTRACE && operation == OperationSettings::Settings::GET ) {
		std::cout << exception.getBacktrace ( );
		return;
	}

	if ( settings == ExceptionSettings::Settings::COMMAND && operation == OperationSettings::Settings::GET ) {
		std::cout << exception.getCommand ( );
		return;
	}

	throw exception::CommonException ( "Component not available" );
}

} /* namespace dataAccess */
