/*
 * RegExpAccess.h
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_ACCESS_H_
#define REG_EXP_ACCESS_H_

#include <core/multipleDispatch.hpp>

#include "regexp/RegExp.h"
#include "regexp/RegExpFeatures.h"

#include "settings/RegExpSettings.h"
#include "settings/OperationSettings.h"
#include <set>

namespace dataAccess {

class RegExpAccess : public alib::SingleDispatch < RegExpAccess, void, regexp::RegExpBase &, const RegExpSettings::Settings &, const OperationSettings::Settings &, ext::deque < sax::Token > & > {
public:
	static void access ( regexp::RegExp & regexp, const RegExpSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );

	static void access ( regexp::UnboundedRegExp < > & regexp, const RegExpSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );
	static void access ( regexp::FormalRegExp < > & regexp, const RegExpSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );
};

} /* namespace dataAccess */

#endif /* REG_EXP_ACCESS_H_ */
