/*
 * GrammarDiff.cpp
 *
 *  Created on: Apr 1, 2013
 *      Author: honza
 */

#include "GrammarDiff.h"
#include <registration/AlgoRegistration.hpp>

namespace compare {

auto GrammarDiffLeftLG = registration::OverloadRegister < GrammarDiff, int, grammar::LeftLG < >, grammar::LeftLG < > > ( GrammarDiff::diff );
auto GrammarDiffLeftRG = registration::OverloadRegister < GrammarDiff, int, grammar::LeftRG < >, grammar::LeftRG < > > ( GrammarDiff::diff );
auto GrammarDiffRightLG = registration::OverloadRegister < GrammarDiff, int, grammar::RightLG < >, grammar::RightLG < > > ( GrammarDiff::diff );
auto GrammarDiffRightRG = registration::OverloadRegister < GrammarDiff, int, grammar::RightRG < >, grammar::RightRG < > > ( GrammarDiff::diff );

auto GrammarDiffLG = registration::OverloadRegister < GrammarDiff, int, grammar::LG < >, grammar::LG < > > ( GrammarDiff::diff );
auto GrammarDiffCFG = registration::OverloadRegister < GrammarDiff, int, grammar::CFG < >, grammar::CFG < > > ( GrammarDiff::diff );
auto GrammarDiffEpsilonFreeCFG = registration::OverloadRegister < GrammarDiff, int, grammar::EpsilonFreeCFG < >, grammar::EpsilonFreeCFG < > > ( GrammarDiff::diff );
auto GrammarDiffCNF = registration::OverloadRegister < GrammarDiff, int, grammar::CNF < >, grammar::CNF < > > ( GrammarDiff::diff );
auto GrammarDiffGNF = registration::OverloadRegister < GrammarDiff, int, grammar::GNF < >, grammar::GNF < > > ( GrammarDiff::diff );
auto GrammarDiffCSG = registration::OverloadRegister < GrammarDiff, int, grammar::CSG < >, grammar::CSG < > > ( GrammarDiff::diff );

auto GrammarDiffNonContractingGrammar = registration::OverloadRegister < GrammarDiff, int, grammar::NonContractingGrammar < >, grammar::NonContractingGrammar < > > ( GrammarDiff::diff );
auto GrammarDiffContextPreservingUnrestrictedGrammar = registration::OverloadRegister < GrammarDiff, int, grammar::ContextPreservingUnrestrictedGrammar < >, grammar::ContextPreservingUnrestrictedGrammar < > > ( GrammarDiff::diff );

auto GrammarDiffUnrestrictedGrammar = registration::OverloadRegister < GrammarDiff, int, grammar::UnrestrictedGrammar < >, grammar::UnrestrictedGrammar < > > ( GrammarDiff::diff );

int GrammarDiff::diff(const grammar::Grammar& a, const grammar::Grammar& b, std::ostream & out ) {
	return dispatch(a.getData(), b.getData(), out);
}

} /* namespace compare */
