/*
 * StringCompare.h
 *
 *  Created on: Apr 4, 2017
 *      Author: Tomas Pecka
 */

#ifndef STRING_COMPARE_H_
#define STRING_COMPARE_H_

#include <core/multipleDispatch.hpp>

#include <string/String.h>
#include <string/StringFeatures.h>
#include "string/CyclicString.h"
#include "string/LinearString.h"

namespace compare {

class StringCompare : public alib::MultipleDispatch < StringCompare, bool, ext::tuple < >, ext::tuple < const string::StringBase &, const string::StringBase & >, ext::tuple < > > {
public:
	template < class SymbolType >
	static bool compare ( const string::LinearString < SymbolType > & a, const string::LinearString < SymbolType > & b );

	template < class SymbolType >
	static bool compare ( const string::CyclicString < SymbolType > & a, const string::CyclicString < SymbolType > & b );

	static bool compare ( const string::String & a, const string::String & b );
};

template < class SymbolType >
bool StringCompare::compare ( const string::LinearString < SymbolType > & a, const string::LinearString < SymbolType > & b ) {
	return		a.getAlphabet ( ) == b.getAlphabet ( ) &&
			a.getContent ( ) == b.getContent ( ) ;
}

template < class SymbolType >
bool StringCompare::compare ( const string::CyclicString < SymbolType > &, const string::CyclicString < SymbolType > & ) {
	throw "NYI";
}

} /* namespace compare */

#endif /* STRING_COMPARE_H_ */
