/*
 * StringDiff.cpp
 *
 *  Created on: Apr 4, 2017
 *      Author: Tomas Pecka
 */

#include "StringDiff.h"
#include <registration/AlgoRegistration.hpp>

namespace compare {

auto StringDiffLinear = registration::OverloadRegister < StringDiff, int, string::LinearString < >, string::LinearString < > > ( StringDiff::diff );
auto StringDiffCyclic = registration::OverloadRegister < StringDiff, int, string::CyclicString < >, string::CyclicString < > > ( StringDiff::diff );

int StringDiff::diff ( const string::String & a, const string::String & b, std::ostream & out ) {
	return dispatch ( a.getData ( ), b.getData ( ), out );
}

} /* namespace compare */
