#include <ast/statements/ContainerFileStatement.h>
#include <ast/Statement.h>
#include <ast/Option.h>
#include <ast/Arg.h>
#include <abstraction/XmlRegistry.h>

namespace cli {

ContainerFileStatement::ContainerFileStatement ( std::string container, std::unique_ptr < TypeOption > type, std::unique_ptr < Arg > file ) : m_file ( std::move ( file ) ), m_container ( std::move ( container ) ), m_type ( std::move ( type ) ) {
}

std::shared_ptr < abstraction::OperationAbstraction > ContainerFileStatement::translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const {
	return abstraction::XmlRegistry::getXmlContainerAbstraction ( m_container, m_type->getType ( ), m_file->eval ( environment ) );
}

} /* namespace cli */
