#ifndef _CLI_CONTAINER_FILE_STATEMENT_H_
#define _CLI_CONTAINER_FILE_STATEMENT_H_

#include <ast/Statement.h>
#include <ast/options/TypeOption.h>

namespace cli {

class ContainerFileStatement final : public Statement {
	std::unique_ptr < cli::Arg > m_file;
	std::string m_container;
	std::unique_ptr < TypeOption > m_type;

public:
	ContainerFileStatement ( std::string container, std::unique_ptr < TypeOption > type, std::unique_ptr < Arg > file );

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override;
};

} /* namespace cli */

#endif /* _CLI_CONTAINER_FILE_STATEMENT_H_ */
