#include <ast/statements/FileStatement.h>
#include <ast/Statement.h>
#include <ast/Option.h>
#include <ast/Arg.h>
#include <abstraction/XmlRegistry.h>

#include <sax/FromXMLParserHelper.h>

namespace cli {

FileStatement::FileStatement ( std::unique_ptr < TypeOption > type, std::unique_ptr < Arg > file ) : m_file ( std::move ( file ) ), m_type ( std::move ( type ) ) {
}

std::shared_ptr < abstraction::OperationAbstraction > FileStatement::translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const {
	ext::deque < sax::Token > tokens = sax::FromXMLParserHelper::parseInput ( m_file->eval ( environment ) );

	std::string type = "";
	if ( m_type )
		type = m_type->getType ( );
	if ( type == "" )
		type = tokens [ 0 ].getData ( );

	std::shared_ptr < abstraction::OperationAbstraction > res = abstraction::XmlRegistry::getXmlParserAbstraction ( type, std::move ( tokens ) );
	res->eval ( );
	return res;
}

} /* namespace cli */
