/*
 * Object.cpp
 *
 *  Created on: Aug 17, 2015
 *      Author: Jan Travnicek
 */

#include "Object.h"
#include <primitive/Integer.h>
#include <primitive/Character.h>
#include <primitive/String.h>
#include <container/ObjectsPair.h>

namespace alib {

void Object::inc ( ) {
	this->operator ++ ( );
}

Object::Object ( int number ) : alib::WrapperBase < ObjectBase > ( primitive::Integer ( number ) ) {
}

Object::Object ( int number1, int number2 ) : Object ( Object { primitive::Integer ( number1 ) }, Object { primitive::Integer ( number2 ) } ) {
}

Object::Object ( Object object1, Object object2 ) : alib::WrapperBase < ObjectBase > ( container::ObjectsPair < Object, Object > { ext::make_pair ( std::move ( object1 ), std::move ( object2 ) ) } ) {
}

Object::Object ( char character ) : alib::WrapperBase < ObjectBase > ( primitive::Character ( character ) ) {
}

Object::Object ( std::string string ) : alib::WrapperBase < ObjectBase > ( primitive::String ( std::move ( string ) ) ) {
}

Object::Object ( const char * string ) : Object ( ( std::string ) string ) {
}

}
