/*
 * BarSymbol.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Stepan Plachy
 */

#include "BarSymbol.h"
#include "Symbol.h"
#include <object/Object.h>
#include "UniqueSymbol.h"

#include <registration/ValuePrinterRegistration.hpp>

namespace alphabet {

BarSymbol::BarSymbol() {

}

SymbolBase* BarSymbol::clone() const {
	return new BarSymbol(*this);
}

SymbolBase* BarSymbol::plunder() && {
	return new BarSymbol(std::move(*this));
}

int BarSymbol::compare(const BarSymbol&) const {
	return 0;
}

void BarSymbol::operator>>(std::ostream& out) const {
	out << "(Bar symbol)";
}

BarSymbol::operator std::string () const {
	return BarSymbol::instance < std::string > ( );
}

SymbolBase* BarSymbol::inc() && {
	return new UniqueSymbol(Symbol(std::move(*this)), primitive::Integer(0));
}

} /* namespace alphabet */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alphabet::BarSymbol > ( );

} /* namespace */
