/*
 * CyclicString.cpp
 *
 *  Created on: Nov 23, 2013
 *	  Author: Jan Travnicek
 */

#include "CyclicString.h"
#include "String.h"
#include <object/Object.h>

#include <registration/CastRegistration.hpp>
#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace {

static auto CyclicStringFromEpsilon = registration::CastRegister < string::CyclicString < >, string::Epsilon < > > ( );

static auto valuePrinter = registration::ValuePrinterRegister < string::CyclicString < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < string::String, string::CyclicString < > > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < alib::Object, string::CyclicString < > > ( );

static auto xmlReader = registration::XmlReaderRegister < string::String, string::CyclicString < > > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < alib::Object, string::CyclicString < > > ( );

} /* namespace */
