/*
 * StringBase.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_BASE_H_
#define STRING_BASE_H_

#include <object/ObjectBase.h>

#include <core/xmlApi.hpp>

namespace string {

/**
 * Represents symbol in an alphabet.
 */
class StringBase : public alib::ObjectBase {
public:
	virtual StringBase * clone ( ) const = 0;
	virtual StringBase * plunder ( ) && = 0;
};

} /* namespace string */

namespace alib {

template < typename Type >
struct xmlApi < Type, typename std::enable_if < std::is_base_of < string::StringBase, Type >::value >::type > {
	static Type parse ( ext::deque < sax::Token >::iterator & input ) {
		return Type::parse ( input );
	}

	static bool first ( const ext::deque < sax::Token >::const_iterator & input ) {
		return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName() );
	}

	static std::string xmlTagName ( ) {
		return Type::getXmlTagName();
	}

	static void compose ( ext::deque < sax::Token > & output, const Type & data ) {
		Type::compose ( output, data );
	}

};

} /* namespace alib */

#endif /* STRING_BASE_H_ */
