/*
 * RankedPattern.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "RankedPattern.h"
#include "../Tree.h"
#include "../RankedTreeWrapper.h"
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < tree::RankedPattern < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < tree::Tree, tree::RankedPattern < > > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < tree::RankedTreeWrapper, tree::RankedPattern < > > ( );
static auto xmlWrite3 = registration::XmlWriterRegister < alib::Object, tree::RankedPattern < > > ( );

static auto xmlReader = registration::XmlReaderRegister < tree::Tree, tree::RankedPattern < > > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < tree::RankedTreeWrapper, tree::RankedPattern < > > ( );
static auto xmlReaded3 = registration::XmlReaderRegister < alib::Object, tree::RankedPattern < > > ( );

static auto RankedPatternFromUnrankedPattern = registration::CastRegister < tree::RankedPattern < >, tree::UnrankedPattern < > > ( );

static auto name = registration::NameRegister < tree::RankedPattern < > > ( tree::RankedPattern < >::getXmlTagName ( ) );

} /* namespace */
