/*
 * StringToRawComposer.cpp
 *
 *  Created on: Nov 16, 2014
 *      Author: Jan Travnicek
 */

#include <string/StringClasses.h>
#include "StringToRawComposer.h"

#include <registration/AlgoRegistration.hpp>

namespace string {

void StringToRawComposer::compose(std::ostream& out, const String& string) {
	dispatch(out, string.getData());
}

template < class SymbolType >
void StringToRawComposer::compose(std::ostream& out, const LinearString < SymbolType > & string) {
	for(const SymbolType & symbol : string.getContent()) {
		out << ext::to_string ( symbol );
	}
}

auto StringToRawComposerLinearString = registration::OverloadRegister < StringToRawComposer, void, LinearString < > >(StringToRawComposer::compose);

} /* namespace automaton */

