/*
 * TreeFromRawParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef TREE_FROM_RAW_PARSER
#define TREE_FROM_RAW_PARSER

#include <set>
#include <deque>
#include <tree>
#include <sax/Token.h>
#include <tree/TreeFeatures.h>
#include <alphabet/Symbol.h>

namespace tree {

class TreeFromRawParser {
public:
	TreeFromRawParser() {}

	Tree parseTree(ext::deque<sax::Token>::iterator& input) const;
	Tree parseTree(ext::deque<sax::Token>::iterator& input, const ext::set<FEATURES>& features) const;

	RankedTreeWrapper parseRankedTree(ext::deque<sax::Token>::iterator& input) const;
	RankedTreeWrapper parseRankedTree(ext::deque<sax::Token>::iterator& input, const ext::set<FEATURES>& features) const;

private:
	ext::tree < alphabet::Symbol > parseContent(ext::deque<sax::Token>::iterator& input) const;
};

} /* namespace tree */

#endif /* TREE_FROM_RAW_PARSER */
