/*
 * RegExpStringApi.hpp
 *
 * Created on: Oct 12, 2016
 * Author: Jan Travnicek
 */

#ifndef REGEXP_STRING_API_HPP_
#define REGEXP_STRING_API_HPP_

#include "../StringApi.hpp"
#include <regexp/RegExp.h>
#include <regexp/unbounded/UnboundedRegExpStructure.h>

namespace alib {

template < >
struct stringApi < regexp::RegExp > {
	static regexp::RegExp parse ( std::istream & input );
	static void compose ( std::ostream & output, const regexp::RegExp & data );
};

template < >
struct stringApi < regexp::UnboundedRegExp < DefaultSymbolType > > {
	static regexp::UnboundedRegExp < DefaultSymbolType > parse ( std::istream & input );
	static void compose ( std::ostream & output, const regexp::UnboundedRegExp < DefaultSymbolType > & data );
};

template < >
struct stringApi < regexp::UnboundedRegExpStructure < DefaultSymbolType > > {
	static regexp::UnboundedRegExpStructure < DefaultSymbolType > parse ( std::istream & input );
	static void compose ( std::ostream & output, const regexp::UnboundedRegExpStructure < DefaultSymbolType > & data );
};

} /* namespace alib */

#endif /* STRING_API_HPP_ */
