#include "LabelTest.h"

#include "object/Object.h"

#include "factory/StringDataFactory.hpp"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( LabelTest, "label" );
CPPUNIT_TEST_SUITE_REGISTRATION( LabelTest );

void LabelTest::setUp() {
}

void LabelTest::tearDown() {
}

void LabelTest::testEqual() {
	{
		std::string input = "1";
		alib::Object label = alib::StringDataFactory::fromString (input);

		std::string output = alib::StringDataFactory::toString(label);

		CPPUNIT_ASSERT( input == output );

		alib::Object label2 = alib::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( label == label2 );
	}
	{
		std::string input = "aaaa";
		alib::Object label = alib::StringDataFactory::fromString (input);

		std::string output = alib::StringDataFactory::toString(label);

		CPPUNIT_ASSERT( input == output );

		alib::Object label2 = alib::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( label == label2 );
	}
	{
		std::string input = "[1, 2, 3]";
		alib::Object label = alib::StringDataFactory::fromString (input);

		std::string output = alib::StringDataFactory::toString(label);

		CPPUNIT_ASSERT( input == output );

		alib::Object label2 = alib::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( label == label2 );
	}
	{
		std::string input = "<1, 2>";
		alib::Object label = alib::StringDataFactory::fromString (input);

		std::string output = alib::StringDataFactory::toString(label);

		CPPUNIT_ASSERT( input == output );

		alib::Object label2 = alib::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( label == label2 );
	}
}

