/*
 * LabelFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_FROM_STRING_LEXER_H_
#define LABEL_FROM_STRING_LEXER_H_

#include <string>
#include <istream>

namespace label {

class LabelFromStringLexer {
public:
	enum class TokenType {
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	static Token next(std::istream& input);
	static void putback(std::istream& input, Token token);
};

} /* namespace label */

#endif /* LABEL_FROM_STRING_LEXER_H_ */
