/*
 * PrimitiveRegistrator.cpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#include <abstraction/XmlFileWriterRegistry.hpp>
#include <abstraction/XmlParserRegistry.hpp>
#include <abstraction/XmlContainerRegistry.hpp>

#include <primitive/xml/Double.h>
#include <primitive/xml/Integer.h>
#include <primitive/xml/Unsigned.h>
#include <primitive/xml/Bool.h>
#include <primitive/xml/UnsignedLong.h>
#include <primitive/xml/String.h>

#include <container/xml/ObjectsVector.h>
#include <container/xml/ObjectsSet.h>

namespace {

class PrimitiveRegistrator {
public:
	PrimitiveRegistrator ( ) {
		abstraction::XmlContainerRegistry::registerSet < int > ( );
		abstraction::XmlParserRegistry::registerXmlParser < int > ( "int" );

		abstraction::XmlFileWriterRegistry::registerXmlFileWriter < bool > ( );
		abstraction::XmlFileWriterRegistry::registerXmlFileWriter < int > ( );
		abstraction::XmlFileWriterRegistry::registerXmlFileWriter < double > ( );
		abstraction::XmlFileWriterRegistry::registerXmlFileWriter < std::string > ( );

		abstraction::XmlFileWriterRegistry::registerXmlFileWriter < ext::vector < size_t > > ( );
		abstraction::XmlFileWriterRegistry::registerXmlFileWriter < ext::vector < unsigned > > ( );
		abstraction::XmlFileWriterRegistry::registerXmlFileWriter < ext::vector < int > > ( );
		abstraction::XmlFileWriterRegistry::registerXmlFileWriter < ext::set < size_t > > ( );
		abstraction::XmlFileWriterRegistry::registerXmlFileWriter < ext::set < unsigned > > ( );
		abstraction::XmlFileWriterRegistry::registerXmlFileWriter < ext::set < int > > ( );
	}
};

auto primitiveRegistrator = PrimitiveRegistrator ( );

} /* namespace */
