/*
 * XmlFileWriterRegistry.cpp
 *
 *  Created on: 21. 8. 2017
 *	  Author: Jan Travnicek
 */

#include <abstraction/XmlFileWriterRegistry.hpp>

namespace abstraction {

std::shared_ptr < abstraction::OperationAbstraction > XmlFileWriterRegistry::getAbstraction ( const std::string & param, std::string filename ) {
	auto res = getEntries ( ).find ( param );
	if ( res == getEntries ( ).end ( ) )
		throw exception::CommonException ( "Entry " + param + " not available." );

	return res->second->getAbstraction ( std::move ( filename ) );
}

ext::set < std::string > XmlFileWriterRegistry::listGroup ( const std::string & group ) {
	ext::set < std::string > res;

	for ( const std::pair < const std::string, std::unique_ptr < Entry > > & entry : getEntries ( ) )
		if ( entry.first.find ( group ) == 0 ) //found at the begining
			res.insert ( entry.first );

	return res;
}

ext::set < std::string > XmlFileWriterRegistry::list ( ) {
	ext::set < std::string > res;

	for ( const std::pair < const std::string, std::unique_ptr < Entry > > & entry : getEntries ( ) )
		res.insert ( entry.first );

	return res;
}

} /* namespace abstraction */
