/*
 * XmlRegistry.cpp
 *
 *  Created on: 10. 7. 2017
 *	  Author: Jan Travnicek
 */

#include <abstraction/XmlRegistry.h>

#include <abstraction/XmlParserRegistry.hpp>
#include <abstraction/XmlFileWriterRegistry.hpp>
#include <abstraction/XmlComposerRegistry.hpp>
#include <abstraction/XmlContainerRegistry.hpp>

#include <core/namingApi.hpp>

namespace abstraction {

ext::set < std::string > XmlRegistry::listDataTypes ( ) {
	return XmlFileWriterRegistry::list ( );
}

ext::set < std::string > XmlRegistry::listDataTypeGroup ( const std::string & group ) {
	return XmlFileWriterRegistry::listGroup ( group );
}

std::shared_ptr < abstraction::OperationAbstraction > XmlRegistry::getXmlContainerAbstraction ( const std::string & container, const std::string & type, const std::string & filename ) {
	return XmlContainerRegistry::getAbstraction ( container, type, filename );
}

std::shared_ptr < abstraction::OperationAbstraction > XmlRegistry::getXmlFileWriterAbstraction ( const std::string & param, std::string filename ) {
	return XmlFileWriterRegistry::getAbstraction ( param, std::move ( filename ) );
}

std::shared_ptr < abstraction::OperationAbstraction > XmlRegistry::getXmlComposerAbstraction ( const std::string & param ) {
	return XmlComposerRegistry::getAbstraction ( param );
}

std::shared_ptr < abstraction::OperationAbstraction > XmlRegistry::getXmlParserAbstraction ( const std::string & typeName, ext::deque < sax::Token > tokens ) {
	return XmlParserRegistry::getAbstraction ( typeName, std::move ( tokens ) );
}

} /* namespace abstraction */
