/*
 * XmlRegistry.h
 *
 *  Created on: 10. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _XML_REGISTRY_H_
#define _XML_REGISTRY_H_

#include <abstraction/OperationAbstraction.hpp>
#include <abstraction/common/ParamQualifiers.hpp>
#include <abstraction/common/AlgorithmCategories.hpp>

#include <deque>
#include <sax/Token.h>

namespace abstraction {

class XmlRegistry {
public:
	static ext::set < std::string > listDataTypes ( );
	static ext::set < std::string > listDataTypeGroup ( const std::string & group );

	static std::shared_ptr < abstraction::OperationAbstraction > getXmlContainerAbstraction ( const std::string & container, const std::string & type, const std::string & filename );
	static std::shared_ptr < abstraction::OperationAbstraction > getXmlFileWriterAbstraction ( const std::string & param, std::string filename );
	static std::shared_ptr < abstraction::OperationAbstraction > getXmlComposerAbstraction ( const std::string & param );
	static std::shared_ptr < abstraction::OperationAbstraction > getXmlParserAbstraction ( const std::string & typeName, ext::deque < sax::Token > tokens );
};

} /* namespace abstraction */

#endif /* _XML_REGISTRY_H_ */

