/*
 * AnyObject.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef _XML_ANY_OBJECT_H_
#define _XML_ANY_OBJECT_H_

#include <object/AnyObject.h>
#include <core/xmlApi.hpp>

namespace alib {

template < typename T >
struct xmlApi < alib::AnyObject < T > > {
	static alib::AnyObject < T > parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static const std::string & xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, const alib::AnyObject < T > & data );
};

template < typename T >
alib::AnyObject < T > xmlApi < alib::AnyObject < T > >::parse ( ext::deque < sax::Token >::iterator & input ) {
	return alib::AnyObject < T > ( alib::xmlApi < T >::parse ( input ) );
}

template < typename T >
bool xmlApi < alib::AnyObject < T > >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return alib::xmlApi < T >::first ( input );
}

template < typename T >
const std::string & xmlApi < alib::AnyObject < T > >::xmlTagName ( ) {
	return alib::xmlApi < T >::xmlTagName ( );
}

template < typename T >
void xmlApi < alib::AnyObject < T > >::compose ( ext::deque < sax::Token > & output, const alib::AnyObject < T > & input ) {
	alib::xmlApi < T >::compose ( output, input.getData ( ) );
}

} /* namespace alib */

#endif /* _XML_ANY_OBJECT_H_ */
