/*
 * Double.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef _XML_PRIMITIVE_DOUBLE_H_
#define _XML_PRIMITIVE_DOUBLE_H_

#include <primitive/Double.h>
#include <core/xmlApi.hpp>

namespace alib {

template < >
struct xmlApi < double > {
	static int parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static const std::string & xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, double data );
};

template < >
struct xmlApi < primitive::Double > {
	static primitive::Double parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static const std::string & xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, const primitive::Double & data );
};

} /* namespace alib */

#endif /* _XML_PRIMITIVE_DOUBLE_H_ */
