/*
 * Unsigned.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef _XML_PRIMITIVE_UNSIGNED_H_
#define _XML_PRIMITIVE_UNSIGNED_H_

#include <primitive/Unsigned.h>
#include <core/xmlApi.hpp>

namespace alib {

template < >
struct xmlApi < unsigned > {
	static unsigned parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static const std::string & xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, unsigned data );
};

template < >
struct xmlApi < primitive::Unsigned > {
	static primitive::Unsigned parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static const std::string & xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, const primitive::Unsigned & data );
};

} /* namespace alib */

#endif /* _XML_PRIMITIVE_UNSIGNED_H_ */
