/*
 * UnsignedLong.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef _XML_PRIMITIVE_UNSIGNED_LONG_H_
#define _XML_PRIMITIVE_UNSIGNED_LONG_H_

#include <primitive/UnsignedLong.h>
#include <core/xmlApi.hpp>

namespace alib {

template < >
struct xmlApi < unsigned long > {
	static unsigned long parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static const std::string & xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, unsigned long data );
};

template < >
struct xmlApi < primitive::UnsignedLong > {
	static primitive::UnsignedLong parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static const std::string & xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, const primitive::UnsignedLong & data );
};

} /* namespace alib */

#endif /* _XML_PRIMITIVE_UNSIGNED_LONG_H_ */
