#ifndef _TYPE_REGISTRATION_HPP_
#define _TYPE_REGISTRATION_HPP_

#include <core/xmlApi.hpp>

#include <abstraction/XmlFileWriterRegistry.hpp>
#include <abstraction/XmlComposerRegistry.hpp>
#include <abstraction/XmlParserRegistry.hpp>

namespace registration {

template < class Group, class Type >
class XmlReaderRegister {
public:
	XmlReaderRegister ( ) {
		alib::xmlApi < Group >::template registerXmlReader < Type > ( );

		abstraction::XmlParserRegistry::registerXmlParser < Type > ( );
	}
};

template < class Group, class Type >
class XmlWriterRegister {
public:
	XmlWriterRegister ( ) {
		alib::xmlApi < Group >::template registerXmlWriter < Type > ( );

		abstraction::XmlFileWriterRegistry::registerXmlFileWriter < Type > ( );
		abstraction::XmlComposerRegistry::registerXmlComposer < Type > ( );
	}
};

} /* namespace registration */

#endif // _TYPE_REGISTRATION_HPP_
