/*
 * Prompt.h
 *
 *  Created on: 20. 3. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _AQL_PROMPT_H_
#define _AQL_PROMPT_H_

#include <string>
#include <parser/Parser.h>

class Prompt {
	Prompt ( const Prompt & ) = delete;
	Prompt ( Prompt && ) = delete;
	Prompt & operator = ( const Prompt & ) = delete;
	Prompt & operator = ( Prompt && ) = delete;

	std::string m_prefix;
	std::string m_history_file;

	cli::Environment m_environment;

	char * stripwhite ( char * begin );

public:
	Prompt ( cli::Environment environment );
	~Prompt ( );

	cli::Command::Result run ( );
	cli::Command::Result execute_line ( std::string line );
};

#endif /* _AQL_PROMPT_H_ */
